//
//  AppDelegate.m
//  OS X Example
//
//  Created by Amin Negm-Awad on Fr.,17.01.14.
//  Copyright (c) 2014 Objective-Cloud. All rights reserved.
//

#import "AppDelegate.h"
#import "Service.h"

@implementation AppDelegate

- (IBAction)sendSynchronously:(id)sender
{
	NSString *response = [Service sayHelloTo:self.inputTextField.stringValue];
	if ([response isObjectiveCloudError])
	{
		NSError *error = [response objectiveCloudError];
		response = [NSString stringWithFormat:@"Error: %@", [error localizedDescription]];
	}
	self.outputTextField.stringValue = response;
}

- (IBAction)sendAsynchronously:(id)sender
{
	NSString *personName = self.inputTextField.stringValue;
	id<ServiceCloudInterface> invocation = [Service invokeWithHandler: // A
	^(BOOL success, id response)
	{
		if (!success)
		{
			response = [NSString stringWithFormat:@"Error: %@", [response localizedDescription]];
		}
		self.outputTextField.stringValue = response;
	}];
	[invocation sayHelloSlowlyTo:personName]; // B
}

- (void)applicationDidFinishLaunching:(NSNotification *)aNotification
{
	[OCCService setUsesRemoteHost:YES];

	[Service linkToCloudApp:@"clienttutorial" protocol:@protocol(ServiceCloudInterface) handler:
	 ^(__unsafe_unretained Class serviceClass, NSError *error)
	 {
		 if (serviceClass!=Nil)
		 {
			 self.isLinked = YES;
		 }
		 else
		 {
			 NSLog(@"Could not connect %@. Error %@", NSStringFromClass(serviceClass), error);
		 }
	 }];
}

@end
