#import "ViewController.h"
#import "Service.h"
#import "ServiceCloudInterface.h"

@interface ViewController ()
@property (weak, nonatomic) IBOutlet UITextField *input;
@property (weak, nonatomic) IBOutlet UILabel *output;

@end

@implementation ViewController

- (void)viewDidLoad {
  [super viewDidLoad];
  
  // TESTING ON YOUR DEVICE:
  // If you want to test on your device open Terminal and execute:
  //    $ hostname
  // Then uncomment the following two lines.
  // NSString *localHostWithPort = @"YOUR_HOST_NAME:10000";
  // [OCCService setLocalHost:localHostWithPort];
  
  [Service linkToCloudApp:@"clienttutorial"
                 protocol:@protocol(ServiceCloudInterface)
                  handler:^(__unsafe_unretained Class serviceClass, NSError *error) {
                    NSLog(@"Linked!");
                  }];
}

- (IBAction)sendSynchronously:(id)sender {
  NSString *response = [Service sayHelloTo:self.input.text];
  if(response.isObjectiveCloudError) {
    NSLog(@"error: %@", response);
  } else {
    self.output.text = response;
  }
}

- (IBAction)sendAsynchronously:(id)sender {
  id<ServiceCloudInterface> invocation = [Service invokeWithHandler:^(BOOL success, id value) {
    if(success) {
      self.output.text = value;
    }
  }];
  [invocation sayHelloTo:self.input.text];
}

@end
